#include <bits/stdc++.h>
using namespace std;
int main(){
ios_base::sync_with_stdio(false);
long int n,m,c,x=0;
cin>>n>>m;
long int a[n],b[m];
long int z = n-m;
for(int i=1;i<=m;i++){
        cin>>b[i];

}
for(int i=1;i<=n;i++){
        a[i]= i;

}
for(int i=0;i<=z;i++){
for(int j=1;j<=m;j++){

  a[i + b[j]] = a[i + j];

 }

}
cin>>c;
for(int i=1;i<=n;i++){
        x+=(pow(c,i)*a[i]);
}
cout<<x;





}